import { Program } from "anchor-17";
import { PublicKey } from "@solana/web3.js";
import { UseAccountState } from "@strata-foundation/react";
import BN from "bn.js";
export declare const CANDY_MACHINE_PROGRAM: PublicKey;
/**
 * Unified token bonding interface wrapping the raw TokenBondingV0
 */
export interface ICandyMachine {
    authority: PublicKey;
    publicKey: PublicKey;
    program: Program;
    itemsAvailable: number;
    itemsRedeemed: number;
    itemsRemaining: number;
    treasury: PublicKey;
    tokenMint: PublicKey;
    isSoldOut: boolean;
    isActive: boolean;
    isPresale: boolean;
    isWhitelistOnly: boolean;
    goLiveDate: BN;
    price: BN;
    gatekeeper: null | {
        expireOnUse: boolean;
        gatekeeperNetwork: PublicKey;
    };
    endSettings: null | {
        number: BN;
        endSettingType: any;
    };
    whitelistMintSettings: null | {
        mode: any;
        mint: PublicKey;
        presale: boolean;
        discountPrice: null | BN;
    };
    hiddenSettings: null | {
        name: string;
        uri: string;
        hash: Uint8Array;
    };
    retainAuthority: boolean;
}
export declare const useCandyMachine: (candyMachineId: PublicKey | undefined | null) => UseAccountState<ICandyMachine>;
//# sourceMappingURL=useCandyMachine.d.ts.map